/************************************************************************************/
//    ˾ƣ            KT Micro, Inc.
//
//    ģ              KT0937ģ
//        V1.5.0
//      ˣWujinfeng                   ʱ䣺2014-09-12
//      ˣKangHekai                   ʱ䣺2017-06-21
//    
//    ˵ Revision History
//    Version   Date              Description
//    V1.0.0    2014-09-12        Initial draft version
//    V1.1.0    2016-12-27        ޸KT093x_ADC_ConfigرյʱҪ0x71bit7д1ٴοʱ0x71bit7д0дbit2Ϊ1.
//    V1.2.0    2017-03-21        ޸RCLK_ENĴ4bitbug
//    V1.5.0    2017-06-21        ޸KT_AMFM_Initȫʼݡ궨塣
/************************************************************************************/

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include "KT_AMFMdrv.h"
#include <math.h>
#include <stdio.h>

struct Str_Band code KT093xBand[16]=
{
  {FM_MODE,FM_BAND_BOTTOM/5,FM_STEP,(FM_BAND_TOP-FM_BAND_BOTTOM)/FM_STEP,ADCGUARD,(((FM_BAND_TOP-FM_BAND_BOTTOM)/FM_STEP) << 1) + (2 * ADCGUARD)},
  {MW_MODE,MW_BAND_BOTTOM,MW_STEP,(MW_BAND_TOP-MW_BAND_BOTTOM)/MW_STEP,ADCGUARD,((MW_BAND_TOP-MW_BAND_BOTTOM)/MW_STEP << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW1_BOTTOM_LIMIT,SW_STEP,(SW1_TOP_LIMIT-SW1_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW1_TOP_LIMIT-SW1_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW2_BOTTOM_LIMIT,SW_STEP,(SW2_TOP_LIMIT-SW2_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW2_TOP_LIMIT-SW2_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW3_BOTTOM_LIMIT,SW_STEP,(SW3_TOP_LIMIT-SW3_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW3_TOP_LIMIT-SW3_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW4_BOTTOM_LIMIT,SW_STEP,(SW4_TOP_LIMIT-SW4_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW4_TOP_LIMIT-SW4_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW5_BOTTOM_LIMIT,SW_STEP,(SW5_TOP_LIMIT-SW5_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW5_TOP_LIMIT-SW5_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW6_BOTTOM_LIMIT,SW_STEP,(SW6_TOP_LIMIT-SW6_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW6_TOP_LIMIT-SW6_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW7_BOTTOM_LIMIT,SW_STEP,(SW7_TOP_LIMIT-SW7_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW7_TOP_LIMIT-SW7_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW8_BOTTOM_LIMIT,SW_STEP,(SW8_TOP_LIMIT-SW8_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW8_TOP_LIMIT-SW8_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW9_BOTTOM_LIMIT,SW_STEP,(SW9_TOP_LIMIT-SW9_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW9_TOP_LIMIT-SW9_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW10_BOTTOM_LIMIT,SW_STEP,(SW10_TOP_LIMIT-SW10_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW10_TOP_LIMIT-SW10_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW11_BOTTOM_LIMIT,SW_STEP,(SW11_TOP_LIMIT-SW11_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW11_TOP_LIMIT-SW11_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW12_BOTTOM_LIMIT,SW_STEP,(SW12_TOP_LIMIT-SW12_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW12_TOP_LIMIT-SW12_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW13_BOTTOM_LIMIT,SW_STEP,(SW13_TOP_LIMIT-SW13_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW13_TOP_LIMIT-SW13_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
  {SW_MODE,SW14_BOTTOM_LIMIT,SW_STEP,(SW14_TOP_LIMIT-SW14_BOTTOM_LIMIT)/SW_STEP,ADCGUARD,(((SW14_TOP_LIMIT-SW14_BOTTOM_LIMIT)/SW_STEP) << 1) + (2 * ADCGUARD)},
 };
/************************************************************************************/
/*  KT_Byte_Write                                                           */
/*д                                                              */
/*˵                                                                        */
/*úI2C_Byte_Write()                                                        */
/*ȫֱ                                                                      */
/*    룺uchar Register_Address, UINT8 Byte_Data                                 */
/*    أ                                                                      */
/*  ߣKanghekai                ʱ䣺                                         */
/*  ߣYangFen                    ʱ䣺2012-11-15                             */
/*    V1.0                                                                    */
/************************************************************************************/
void KT_Byte_Write(UINT8 Register_Address, UINT8 Byte_Data)
{
#ifdef I2C
    I2C_Byte_Write(KTAMw_address,Register_Address,Byte_Data);
#endif
}

/************************************************************************************/
/*  KT_Byte_Read                                                            */
/*߶                                                              */
/*˵                                                                        */
/*úI2C_Byte_Read()                                                         */
/*ȫֱ                                                                      */
/*    룺uchar Register_Address                                                  */
/*    أuchar readdata                                                          */
/*  ߣKanghekai                ʱ䣺                                         */
/*  ߣYangFen                  ʱ䣺2012-11-15                               */
/*    V1.0                                                                    */
/************************************************************************************/
UINT8 KT_Byte_Read(UINT8 Register_Address)
{
#ifdef I2C
    return( I2C_Byte_Read(KTAMr_address, Register_Address) );
#endif
}

/************************************************************************************/
/*  KT_AMFM_PreInit                                                         */
/*˲оƬI2Cд                                                     */
/*˵                                                                        */
/*úKT_Byte_Read()KT_Byte_Write()                                         */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أȷ1                 0                                         */
/*  ߣKanghekai               ʱ䣺                                          */
/*  ߣZhoudongfeng            ʱ䣺2013-06-18                                */
/*    V1.1    Add and "Read Manufactory ID"                                   */
/************************************************************************************/
UINT8 KT_AMFM_PreInit(void)              
{
    UINT16 regx;
    UINT8 regy;
    UINT8 i;
    for (i = 0;i < 10;i++)
    {
        Delay_ms(10);
        regx = KT_Byte_Read(0x02);                       //Read Manufactory ID 
        regy = KT_Byte_Read(0x03);
        regx = ( (regx << 8) | regy );
          if (regx == 0x4B54) return(1);
    }
    return(0);
}

/************************************************************************************/
/*  KT_AMFM_Init                                                            */
/*оƬʼ                                                          */
/*˵                                                                        */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أȷ1                  0                                        */
/*  ߣYangpei                  ʱ䣺                                         */
/*  ߣKanghekai                ʱ䣺2013-11-27                               */
/*    V1.1    Delete "Delay_ms(3000)",Add while(1) wait                       */
/*                  Add "System clock initialization"                               */
/*          V1.3    AM & FM softmute updata.OPEN "BLEND of SNR"                     */
/*          V1.4.1  1ʹFM75KAM80%һ                       */
/*                  2tuneָʾƵʱFM14dBuVemf9dBuVemf        */
/*                  3tuneָʾƵʱAM71dBuVemf68dBuVemf       */
/*                  4AM                                             */
/*                  5FM                                             */
/*          V1.4.2  AMʱDELTNBUG                                        */
/*          V1.4.3  ޸FM softmuteãsonyҪ               */
/*          V1.4.5  KT_AMFM_Init                                                */
/*          V1.5.0  2017-06-21  ޸KT_AMFM_Initȫʼݡ                  */
/************************************************************************************/
UINT8 KT_AMFM_Init(void)                            //0->Fail 1->Success
{
    UINT8 regx;
//============= System clock initialization =============
    regx = KT_Byte_Read(0x06);
    KT_Byte_Write(0x06, (regx & 0xF8) | DIVIDERN_H);    //ratio_n
    KT_Byte_Write(0x07, DIVIDERN_L);

    regx = KT_Byte_Read(0x08);                            //ⲿʱ
    KT_Byte_Write(0x08, (regx & 0xF0) | FPFD_H);
    KT_Byte_Write(0x09, FPFD_M);
    KT_Byte_Write(0x0A, FPFD_L);

    regx = KT_Byte_Read(0x0D);                            //òοʱ
    KT_Byte_Write(0x0D, (regx & 0xEF) | RCLK_EN<<4);    

    KT_Byte_Write(0x05, DIVIDERP_L);
    regx = KT_Byte_Read(0x04);
    KT_Byte_Write(0x04, (regx & 0xF8) | (SYS_CFGOK << 7) | DIVIDERP_H);     //ratio_p

    regx = KT_Byte_Read(0x0F);
    KT_Byte_Write(0x0F, (regx & 0xF0) | VOLUME );    
    regx = KT_Byte_Read(0x4E);
    KT_Byte_Write(0x4E, (regx & 0xC8) | (DEPOP_TC << 4) | AUDV_DCLVL );    
    
    regx = KT_Byte_Read(0x1F);
    KT_Byte_Write(0x1F, (regx & 0x7F) | (TUNE_INT_PL << 7));//½
    regx = KT_Byte_Read(0x22);
    KT_Byte_Write(0x22, (regx & 0x3F) | (TUNE_INT_EN << 7) | (TUNE_INT_MODE << 6));    //شж
    regx = KT_Byte_Read(0x4F);                                        //INT
    KT_Byte_Write(0x4F, (regx & 0xFC) | INT_PIN);    //شԶж
    
    regx = KT_Byte_Read(0x51);                            
    KT_Byte_Write(0x51, (regx & 0xFC) | CH_PIN);            //chan ģʽ 1Ϊkey2Ϊadc

    regx = KT_Byte_Read(0x76);                            
    KT_Byte_Write(0x76, (regx & 0xF3) | (CHAN_VALIDCODE_SEL << 2));
    while (1)
    {
        regx = KT_Byte_Read(0x1B);                        // ȴϵ
        if ((regx & 0x04) == 0x04) break;
    }

//============= AFC=============
    regx = KT_Byte_Read(0x1B);
    KT_Byte_Write(0x1B, (regx & 0x5F) | (AFC_RST_EN << 7) | (AFC_RST_AUTO_EN << 5));
    
    regx = KT_Byte_Read(0x38);
    KT_Byte_Write(0x38, (regx & 0x7F) | (SW_AFCD << 7));       //Ƿʹ

    regx = KT_Byte_Read(0x3E);
    KT_Byte_Write(0x3E, (regx & 0xB8) | (FM_AFCD << 6) | FM_TH_AFC);       //Ƿʹ

    regx = KT_Byte_Read(0x3F);
    KT_Byte_Write(0x3F, (regx & 0xB8) | (MW_AFCD << 6) | MW_TH_AFC);       //Ƿʹ

    regx = KT_Byte_Read(0x55);
    KT_Byte_Write(0x55, (regx & 0xC0) | (SW_TH_AFC << 3) | MW_Q);               //Χ

//============= MW Baseband Gain =============
    regx = KT_Byte_Read(0x65);            
    KT_Byte_Write(0x65, (regx & 0x8F) | (MW_BBAGC_RATIO << 4) | AM_BBAGC_BW);
    regx = KT_Byte_Read(0x67);            
    KT_Byte_Write(0x67, (regx & 0xC0) | MW_BBAGC_HI_TH);                     //am_bbagc
    regx = KT_Byte_Read(0x68);            
    KT_Byte_Write(0x68, (regx & 0xC0) | MW_BBAGC_LOW_TH);
    regx = KT_Byte_Read(0x69);            
    KT_Byte_Write(0x69, (regx & 0xF0) | MW_VOLUME);

//============= SW Baseband Gain =============
    regx = KT_Byte_Read(0x38);            
    KT_Byte_Write(0x38, (regx & 0x8F) | (SW_BBAGC_RATIO << 4));
    regx = KT_Byte_Read(0x3A);            
    KT_Byte_Write(0x3A, (regx & 0xC0) | SW_BBAGC_HI_TH);
    regx = KT_Byte_Read(0x52);            
    KT_Byte_Write(0x52, (regx & 0xC0) | SW_BBAGC_LOW_TH);
    regx = KT_Byte_Read(0x39);            
    KT_Byte_Write(0x39, (regx & 0xF0) | SW_VOLUME);

//============= audio Gain =============
    regx = KT_Byte_Read(0x2A);            
    KT_Byte_Write(0x2A, (regx & 0x8F) | (FM_GAIN << 4));        //SW_audio_gain
    regx = KT_Byte_Read(0x38);            
    KT_Byte_Write(0x38, (regx & 0xF0) | SW_GAIN);        //SW_audio_gain
    KT_Byte_Write(0x62, (MW_GAIN << 4) | FLT_SEL);        //2.4K

//  =================== Stereo Blend ===================
    regx = KT_Byte_Read(0x29);
    KT_Byte_Write(0x29, (regx & 0xEF) | (BLEND_MOD << 4));    
    regx = KT_Byte_Read(0x2B);
    KT_Byte_Write(0x2B, (regx & 0x76) | (MONO << 7) | (DE << 3) | DBLND);    
    KT_Byte_Write(0x2C, (BLEND_START_RSSI << 4) | BLEND_STOP_RSSI);    //blend rssi
    regx = KT_Byte_Read(0x34);            
    KT_Byte_Write(0x34, (regx & 0xC0) | BLEND_START_SNR);                //blend_start_snr
    regx = KT_Byte_Read(0x35);            
    KT_Byte_Write(0x35, (regx & 0xC0) | BLEND_STOP_SNR);                //blend_stop_snr
    regx = KT_Byte_Read(0x7E);            
    KT_Byte_Write(0x7E, (regx & 0x8F) | (BLEND_START_COMBO << 4));                //blend_stop_snr

//============= SOFTMUTE =============
    regx = KT_Byte_Read(0x16);
    KT_Byte_Write(0x16, (regx & 0xFC) | TUNE_SMUTE_GAIN_FM);
    regx = KT_Byte_Read(0x19);
    KT_Byte_Write(0x19, (regx & 0x03) | (MW_SMUTE_MIN_GAIN << 5) | (FM_SMUTE_MIN_GAIN << 2));
    regx = KT_Byte_Read(0x1A);                 //softmute disable
    KT_Byte_Write(0x1A, (regx & 0x3F) | (FM_DSMUTE << 7) | (MW_DSMUTE << 6));
    regx = KT_Byte_Read(0x1D);
    KT_Byte_Write(0x1D, (regx & 0x80) | MW_SMUTE_START_RSSI);
    regx = KT_Byte_Read(0x1E);
    KT_Byte_Write(0x1E, (regx & 0xF8) | MW_SMUTE_SLOPE_RSSI);

    regx = KT_Byte_Read(0x1F);
    KT_Byte_Write(0x1F, (regx & 0x88) | (FM_SMUTE_START_RSSI << 4) | FM_SMUTE_SLOPE_RSSI);
    regx = KT_Byte_Read(0x20);
    KT_Byte_Write(0x20, (regx & 0x80) | MW_SMUTE_START_SNR);
    regx = KT_Byte_Read(0x21);
    KT_Byte_Write(0x21, (regx & 0x08) | (Q_CTRL_EN << 7) | (MW_SMUTE_SLOPE_SNR << 4) | FM_SMUTE_SLOPE_SNR);
    regx = KT_Byte_Read(0x22);
    KT_Byte_Write(0x22, (regx & 0xC0) | FM_SMUTE_START_SNR);
    regx = KT_Byte_Read(0x23);
    KT_Byte_Write(0x23, (regx & 0xFE) | ADJACENT_SM_EN);
    
    regx = KT_Byte_Read(0x53);
    KT_Byte_Write(0x53, (regx & 0xE3) | (TUNE_SMUTE_GAIN_AM << 2));

    KT_Byte_Write(0xF4, (SW_DSMUTE << 7) | SW_SMUTE_START_SNR);
    KT_Byte_Write(0xF5, SW_SMUTE_START_RSSI);
    regx = KT_Byte_Read(0xF6);
    KT_Byte_Write(0xF6, (regx & 0xC0) | (SW_SMUTE_SLOPE_SNR << 3) | SW_SMUTE_SLOPE_RSSI);
    KT_Byte_Write(0xF7, (SW_SMUTE_MIN_GAIN << 3) | (TUNE_SMUTE_GAIN_SW << 2));

    regx = KT_Byte_Read(0x16);                         
    KT_Byte_Write(0x16, (regx & 0xEF) | (SW_EN << 4));    //sw_en=1

    regx = KT_Byte_Read(0x2F);
    KT_Byte_Write(0x2F, (ANT_CALI_SWITCH_BAND << 5) | (BLEND_COMBO_MODE << 4) | (FM_NBW_CTL_EN << 3) | 
                        (AM_SUP_ENHANCE << 2) | (SMUTE_FILTER_EN << 1) | AM_SEL_ENHANCE);    //޸ĵȿ

    regx = KT_Byte_Read(0x30);                         
    KT_Byte_Write(0x30, (regx & 0xE0) | FM_RSSI_BIAS);
    regx = KT_Byte_Read(0x63);                         
    KT_Byte_Write(0x63, (regx & 0xE0) | AM_RSSI_BIAS);
    
    regx = KT_Byte_Read(0x24);
    KT_Byte_Write(0x24, (regx & 0x7F));

    regx = KT_Byte_Read(0x2D);
    KT_Byte_Write(0x2D, (regx & 0xF8) | SW_GC);
    regx = KT_Byte_Read(0x37);            
    KT_Byte_Write(0x37, (regx & 0xDF) | (LO_SEG_RST_EN << 5));
    regx = KT_Byte_Read(0x3B);            
    KT_Byte_Write(0x3B, (regx & 0x8F) | (TH_AMDEAD << 4));
//    KT_Byte_Write(0x72, 0x83);
//    KT_Byte_Write(0x73, 0x83);
    
#ifdef EMI
    regx = KT_Byte_Read(0x36);                 //loldo_ctrl=1.25
    KT_Byte_Write(0x36, ((regx & 0xCF)| 0x20));
#endif

    return(1);
}     


/************************************************************************************/
/*  KT_AMFM_VolumeSet                                                       */
/*ó                                                            */
/*˵vol=0~31                                                                */
/*úKT_Byte_Read()KT_Byte_Write()                                         */
/*ȫֱmem_vol                                                                 */
/*    룺uchar vol                                                               */
/*    أϣ1                                                             */
/*  ߣYangpei                    ʱ䣺                                       */
/*  ߣYangfen                 ʱ䣺2012-11-19                                */
/*    V1.0                                                                    */
/************************************************************************************/
UINT8 KT_AMFM_VolumeSet(UINT8 cVol)            //Input: 0~31
{
    UINT8 regx;

    regx = KT_Byte_Read(0x0F);
    KT_Byte_Write(0x0F, (regx & 0xE0) | cVol);

    return(1);
}
/************************************************************************************/
/*  KT_FM_ReadRSSI                                                          */
/*FM RSSI                                                           */
/*˵RSSI=-100(dbm) to -6(dbm)                                               */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺char *RSSI                                                              */
/*    أϣ1                                                             */
/*  ߣKanghekai                ʱ䣺                                         */
/*  ߣYangfen                 ʱ䣺2012-11-20                                */
/*    V1.0                                                                    */
/************************************************************************************/
UINT8 KT_FM_ReadRSSI(void) //dbuvmf
{
    UINT8 regx;
    regx = KT_Byte_Read(0xE6);
    return(3 + (regx & 0x7F));
} 

/************************************************************************************/
/*  KT_AMFM_Tuning_Indicator                                                */
/*FM tuningָʾ                                                     */
/*˵                                                                        */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أȷ1                    0                                      */
/*  ߣKanghekai                ʱ䣺                                         */
/*  ߣYangfen                 ʱ䣺2012-11-20                                */
/*    V1.0                                                                    */
/************************************************************************************/
#ifdef DEBUG
BOOL KT_AMFM_Tuning_Indicator(void)
{
    UINT8 regx;

    regx = KT_Byte_Read(0xDE);
    regx = regx & 0x04;
        
    return(regx);
}
#endif
/************************************************************************************/
/*  KT_FM_GetSNR                                                            */
/*FM SNR                                                            */
/*˵                                                                        */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أuchar SNR                                                               */
/*  ߣYanpei                ʱ䣺                                            */
/*  ߣYangfen                ʱ䣺2012-11-20                                 */
/*    V1.0                                                                    */
/************************************************************************************/
UINT8 KT_FM_GetSNR(void)
{
    UINT8 regx;
    regx = KT_Byte_Read(0xE2);
    regx = regx & 0x3F;
    return(regx);
}

/************************************************************************************/
/*  KT_AM_ReadRSSI                                                          */
/*AM RSSI                                                           */
/*˵RSSI=-90(dbm) to -6(dbm)                                                */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أϣ1                                                             */
/*  ߣKanghekai                ʱ䣺                                         */
/*  ߣYangfen                 ʱ䣺2012-11-20                                */
/*    V1.0                                                                    */
/************************************************************************************/
UINT8 KT_AM_ReadRSSI(void) //range from -90 to -6, unit is dbm
{
    UINT8 regx;
    regx = KT_Byte_Read(0xEA);
    return(3+(regx & 0x7F));
}

#ifdef DEBUG
/************************************************************************************/
/*  KT_AM_GetCap                                                            */
/*                                                                        */
/*˵                                                                        */
/*úKT_Byte_Read()                                                          */
/*ȫֱFM_SNR_TH                                                               */
/*    룺                                                                      */
/*    أȷ1                  0                                        */
/*  ߣKanghekai                ʱ䣺                                         */
/*  ߣKanghekai                ʱ䣺2014-03-13                               */
/*    V1.1                                                                    */
/*          V1.2    2014-03-13    ֵȼɵĴ                */
/************************************************************************************/
UINT16 KT_AM_GetCap(void)
{
    UINT8 regx,regy;

    regx = KT_Byte_Read(0x56);           // read CAP
    regy = KT_Byte_Read(0x57);
    return(((regx & 0x3F) << 8) | regy );
}
#endif

/************************************************************************************/
/*  KT_AM_GetSNR                                                            */
/*AM SNR                                                            */
/*˵                                                                        */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أuchar SNR                                                               */
/*  ߣYanpei                 ʱ䣺                                           */
/*  ߣYangfen                ʱ䣺2012-11-20                                 */
/*    V1.0                                                                    */
/************************************************************************************/
UINT8 KT_AM_GetSNR(void)
{
    UINT8 regx;
    regx = KT_Byte_Read(0xEC);
    regx = regx & 0x7F;
    return(regx);
}

/************************************************************************************/
/*  KT_FM_GetFreq                                                           */
/*FMǰ̨Ƶʳ                                                    */
/*˵                                                                        */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أ                                                                        */
/*  ߣKanghekai               ʱ䣺                                          */
/*  ߣYangfen                 ʱ䣺2012-11-20                                */
/*    V1.0                                                                    */
/************************************************************************************/
UINT16 KT_FM_GetFreq(void)
{
    UINT16 temp;
    temp= (KT_AM_GetFreq()*5);
    return(temp);
}

/************************************************************************************/
/*  KT_AM_GetFreq                                                           */
/*AMǰ̨Ƶʳ                                                    */
/*˵                                                                        */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أ                                                                        */
/*  ߣKanghekai               ʱ䣺                                          */
/*  ߣYangfen                 ʱ䣺2012-11-20                                */
/*    V1.0                                                                    */
/************************************************************************************/
UINT16 KT_AM_GetFreq(void)
{
    UINT8 regx,regy;
    UINT16 a;

    regx = KT_Byte_Read(0xe4);
    regy = KT_Byte_Read(0xe5);
    a = ((regx & 0x7F) << 8) | regy ;
    return(a);
}

/************************************************************************************/
/*  KT_AMFM_GetST                                                           */
/*FM STָʾ                                                         */
/*˵                                                                        */
/*úKT_Byte_Read()                                                          */
/*ȫֱ                                                                      */
/*    룺                                                                      */
/*    أ1                0                                      */
/*  ߣKanghekai                ʱ䣺                                         */
/*  ߣKanghekai                ʱ䣺2014-03-04                               */
/*    V1.0                                                                    */
/************************************************************************************/
BOOL KT_AMFM_GetST(void)
{
    UINT8 regx;

    regx = KT_Byte_Read(0x1C);
        
    return(regx);
}

/************************************************************************************/
/*  KT_AMFM_SetMode                                                         */
/*                                                                */
/*˵                                                                        */
/*úKT_Byte_Read(),KT_Byte_Write(),changeBandDisplay()                      */
/*ȫֱ                                                                      */
/*    룺                                                                        */
/*    أ                                                                      */
/*  ߣWujinfeng               ʱ䣺2014-09-12                                */
/*  ߣ                        ʱ䣺                                          */
/*    V1.0                                                                    */
/************************************************************************************/
void KT_AMFM_SetMode(void)
{
    UINT8 regx;
    KT093x_ADC_Config(OFF);              //disable adc
    KT093x_bandChan_Config();          //lowchan channum adcwinguard
    if(pBand->Band==FM_MODE)
    {
        KT093x_STEP_Config(FM_MODE);                          //step
        KT_Byte_Write(0x89, pBand->BandLowChan & 0xFF );    //write FM channel
        regx = KT_Byte_Read(0x88);     
        KT_Byte_Write(0x88, (regx & 0xB0) | ((pBand->BandLowChan >> 8) & 0x0F) | 0x80 );
    }
    else      //MWSW
    {
        if(pBand->Band==MW_MODE)
        {
            KT093x_STEP_Config(MW_MODE);    
        }
        else
        {
            KT093x_STEP_Config(SW_MODE);    
        }
        KT_Byte_Write(0x8d, pBand->BandLowChan & 0xFF);
        regx = KT_Byte_Read(0x8c);
        KT_Byte_Write(0x8c, (regx & 0x80) | ((pBand->BandLowChan >> 8) & 0x7F));
        regx = KT_Byte_Read(0x88);
        KT_Byte_Write(0x88, regx | 0xC0);       //tuneһ£л
    }
    KT093x_ADC_Config(ON);                       //enable adc
}

/************************************************************************************/
/*  KT093x_ADC_Config                                                       */
/*ADC򿪻ر                                                       */
/*˵                                                                        */
/*úKT_Byte_Read(),KT_Byte_Write()                                          */
/*ȫֱ                                                                      */
/*    룺                                                                        */
/*    أ                                                                      */
/*  ߣWujinfeng               ʱ䣺2014-09-12                                */
/*  ߣ                        ʱ䣺                                          */
/*    V1.0                                                                    */
/*    V1.1       ޸ADCرմӦ޸BIT7                                */
/************************************************************************************/
void KT093x_ADC_Config(BOOL adcSwitch)
{
    UINT8 regx;
    if(ON==adcSwitch)
    {
        regx = KT_Byte_Read(0x71);
        KT_Byte_Write(0x71, (regx & 0X7F) | 0x04); //adc enable
    }
    else
    {
        regx = KT_Byte_Read(0x71);
        KT_Byte_Write(0x71, regx | 0x80);        //adc disable
    }
}
/************************************************************************************/
/*  KT093x_bandChan_Config                                                  */
/*òεlowchanchan_numberguardADCڴС                      */
/*˵                                                                        */
/*úKT_Byte_Read(),KT_Byte_Write()                                          */
/*ȫֱ                                                                      */
/*    룺                                                                        */
/*    أ                                                                      */
/*  ߣWujinfeng               ʱ䣺2014-09-12                                */
/*  ߣ                        ʱ䣺                                          */
/*    V1.0                                                                    */
/************************************************************************************/
void KT093x_bandChan_Config(void)
{
    UINT8 regx;
    KT_Byte_Write(0x98, (pBand->BandLowChan) >> 8);
    KT_Byte_Write(0x99, (pBand->BandLowChan) & 0x00FF);
    KT_Byte_Write(0x9a, (pBand->BandChanNum) >> 8);                            
    KT_Byte_Write(0x9b, (pBand->BandChanNum) & 0x00FF);
    KT_Byte_Write(0xa0, pBand->BandGuard);
    regx = KT_Byte_Read(0x74);
    KT_Byte_Write(0x74, (regx & 0xe0) | (pBand->BandChanWin) >> 8);
    KT_Byte_Write(0x75, (pBand->BandChanWin) & 0x00FF);
}

/************************************************************************************/
/*  KT093x_STEP_Config                                                      */
/*òβ                                                            */
/*˵                                                                        */
/*úKT_Byte_Read(),KT_Byte_Write()                                          */
/*ȫֱ                                                                      */
/*    룺                                                                        */
/*    أ                                                                      */
/*  ߣWujinfeng               ʱ䣺2014-09-12                                */
/*  ߣ                        ʱ䣺                                          */
/*    V1.0                                                                    */
/************************************************************************************/
void KT093x_STEP_Config(enum Band_Mode spanMode)
{
    UINT8 temp;
    UINT8 regx;
    if(spanMode==FM_MODE)
    {
        sw_vcc=0;                               //̲Ŵ·ر
        if(5==(pBand->BandSpace))               //fm space
            temp=0x20;
        else if(10==(pBand->BandSpace))
            temp=0x10;
        else
            temp=0x00;
        regx = KT_Byte_Read(0x18);
        KT_Byte_Write(0x18, (regx & 0xCF) | temp);
    }
    else
    {
        if(spanMode==MW_MODE)
        {
            sw_vcc=0;                         //̲Ŵ·ر
            if(1==(pBand->BandSpace))
                temp=0x00;
            else if(9==(pBand->BandSpace))
                temp=0x01;
            else
                temp=0x02;
            regx = KT_Byte_Read(0x18);
            KT_Byte_Write(0x18, (regx & 0xFC) | temp);
        }
        else
        {
            sw_vcc=1;                        //̲Ŵ·
            if(1==(pBand->BandSpace))
                temp=0x00;
            else if(5==(pBand->BandSpace))
                temp=0x01;
            else if(9==(pBand->BandSpace))
                temp=0x02;
            else
                temp=0x03;
            regx = KT_Byte_Read(0x19);
            KT_Byte_Write(0x19, (regx & 0xFC) | temp);
        }
    }
}