/************************************************************************************/
//    ˾ƣ            KT Micro, Inc.
//
//    ģ              KT0937ģͷļ
//        V1.5.0
//      ˣWujinfeng                   ʱ䣺2014-09-12
//      ˣKangHekai                   ʱ䣺2017-06-21
//    
//    ˵ Revision History
//    Version   Date              Description
//    V1.0.0    2014-09-12        Initial draft version
//    V1.1.0    2016-12-27        ޸KT093x_ADC_ConfigرյʱҪ0x71bit7д1ٴοʱ0x71bit7д0дbit2Ϊ1.
//    V1.2.0    2017-03-21        ޸RCLK_ENĴ4bitbug
//    V1.5.0    2017-06-21        ޸KT_AMFM_Initȫʼݡ궨塣
/************************************************************************************/

#include "interface.h"
//#define FM_DELTN
//#define DEBUG
//#define EMI

#ifndef    FM_DELTN
    #define VolCtrl
#endif

#define KTAMw_address 0x6A
#define KTAMr_address 0x6B

#define CHN_BAND
//#define EUP_BAND
//#define USA_BAND
//#define JPN_BAND

#define X32P768K                    //32.768KHz crystal
//#define R32P768K                  //32.768KHz reference clock
//#define X38K                      //38KHz crystal
//#define R38K                      //38KHz reference clock
//#define R7P6M                     //7.6MHz reference clock
//#define R12M                      //12MHz reference clock
//#define R13M                      //13MHz reference clock
//#define R24M                      //24MHz reference clock
//#define R26M                      //26MHz reference clock

#ifdef X32P768K
    #define XTAL_FREQ       32768
    #define DIVIDERP        1
    #define DIVIDERN        668
    #define SYS_CFGOK       1
    #define RCLK_EN         0
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif
    
#ifdef R32P768K
    #define XTAL_FREQ       32768
    #define DIVIDERP        1
    #define DIVIDERN        668
    #define SYS_CFGOK       1
    #define RCLK_EN         1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef X38K
    #define XTAL_FREQ       38000
    #define DIVIDERP        1
    #define DIVIDERN        576
    #define SYS_CFGOK       1
    #define RCLK_EN         0
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef R38K
    #define XTAL_FREQ       38000
    #define DIVIDERP        1
    #define DIVIDERN        576
    #define SYS_CFGOK       1
    #define RCLK_EN         1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef R7P6M
    #define XTAL_FREQ        7600000
    #define DIVIDERP         200
    #define DIVIDERN         576
    #define SYS_CFGOK        1
    #define RCLK_EN          1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef R12M
    #define XTAL_FREQ       12000000
    #define DIVIDERP        375
    #define DIVIDERN        684
    #define SYS_CFGOK       1
    #define RCLK_EN         1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef R12P288M
    #define XTAL_FREQ       12288000
    #define DIVIDERP        384
    #define DIVIDERN        684
    #define SYS_CFGOK       1
    #define RCLK_EN         1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef R13M
    #define XTAL_FREQ       13000000
    #define DIVIDERP        411
    #define DIVIDERN        692
    #define SYS_CFGOK       1
    #define RCLK_EN         1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef R24M
    #define XTAL_FREQ       24000000
    #define DIVIDERP        750
    #define DIVIDERN        684
    #define SYS_CFGOK       1
    #define RCLK_EN         1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif

#ifdef R26M
    #define XTAL_FREQ       26000000
    #define DIVIDERP        822
    #define DIVIDERN        692
    #define SYS_CFGOK       1
    #define RCLK_EN         1
    
    #define FPFD            (XTAL_FREQ / DIVIDERP * 16)
    #define DIVIDERP_H      (DIVIDERP >> 8)
    #define DIVIDERP_L      (DIVIDERP % 256)
    #define DIVIDERN_H      (DIVIDERN >> 8)
    #define DIVIDERN_L      (DIVIDERN % 256)
    #define FPFD_H          (FPFD >> 16)
    #define FPFD_M          ((FPFD >> 8) & 0x00FF)
    #define FPFD_L          (FPFD % 65536)
#endif


#define FM_50KHz_STEP       5
#define FM_100KHz_STEP      10
#define AM_1KHz_STEP        1
#define AM_5KHz_STEP        5
#define AM_9KHz_STEP        9
#define AM_10KHz_STEP       10

#ifdef CHN_BAND
    #define DE                    1        //0: 75us,        1: 50us
    #define FM_BAND_BOTTOM        8750
    #define FM_BAND_TOP           10850
    #define MW_BAND_BOTTOM        504
    #define MW_BAND_TOP           1710
    #define FM_STEP               FM_100KHz_STEP
    #define MW_STEP               AM_1KHz_STEP  //AM_9KHz_STEP
#endif

#ifdef EUP_BAND
    #define DE                    1        //0: 75us,        1: 50us
    #define FM_BAND_BOTTOM        8750
    #define FM_BAND_TOP           10800
    #define MW_BAND_BOTTOM        504
    #define MW_BAND_TOP           1710
    #define FM_STEP               FM_50KHz_STEP
    #define MW_STEP               AM_1KHz_STEP
#endif

#ifdef USA_BAND
    #define DE                    0        //0: 75us,        1: 50us
    #define FM_BAND_BOTTOM        8750
    #define FM_BAND_TOP           10800
    #define MW_BAND_BOTTOM        500
    #define MW_BAND_TOP           1710
    #define FM_STEP               FM_100KHz_STEP
    #define MW_STEP               AM_1KHz_STEP
#endif

#ifdef JPN_BAND
    #define DE                    1        //0: 75us,        1: 50us
    #define FM_BAND_BOTTOM        7600
    #define FM_BAND_TOP           10800
    #define MW_BAND_BOTTOM        504
    #define MW_BAND_TOP           1710
    #define FM_STEP               FM_100KHz_STEP
    #define MW_STEP               AM_1KHz_STEP
#endif

#define TUNE_INT_PL               0
#define TUNE_INT_EN               1
#define TUNE_INT_MODE             1
#define INT_PIN                   0
#define CH_PIN                    2        //chan ģʽ 1Ϊkey2Ϊadc

#define AM_BBAGC_BW               7
#define MW_BBAGC_RATIO            5
#define MW_BBAGC_HI_TH            0x1B
#define MW_BBAGC_LOW_TH           0x16
#define MW_VOLUME                 10
#define MW_GAIN                   4        //0:6dB, 1:3dB, 2:0dB, 3:-3dB, 4:-6dB, 5:-9dB, 6:-12dB, 7:-15dB, 8:-18dB

#define SW_BBAGC_RATIO            5
#define SW_BBAGC_HI_TH            0x1B
#define SW_BBAGC_LOW_TH           0x16
#define SW_VOLUME                 10
#define SW_GAIN                   4        //0:6dB, 1:3dB, 2:0dB, 3:-3dB, 4:-6dB, 5:-9dB, 6:-12dB, 7:-15dB, 8:-18dB

#define ANT_CALI_SWITCH_BAND      1
#define BLEND_COMBO_MODE          1
#define FM_NBW_CTL_EN             0
#define AM_SUP_ENHANCE            0
#define SMUTE_FILTER_EN           0
#define AM_SEL_ENHANCE            0

#define ADJACENT_SM_EN            1
#define SW_GC                     6
#define LO_SEG_RST_EN             0
#define TH_AMDEAD                 0
#define AFC_RST_EN                0 
#define AFC_RST_AUTO_EN           1
#define CHAN_VALIDCODE_SEL        1

#define FM_RSSI_BIAS              0
#define AM_RSSI_BIAS              0
#define MW_Q                      4
#define Q_CTRL_EN                 1

#define ON                        1
#define OFF                       0
#define VOLUME                    31
#define ADCGUARD                  16
#define BLEND_START_SNR           63
#define BLEND_STOP_SNR            63
#define BLEND_START_RSSI          5       //0:8, 1:10, 2:12, 3:14, 4:16, 5:18, 6:20, 7:22, 8:24, 9:26, 10:28, 11:30, 12:32, 13:34, 14:36, 15:38(unit:dbuVEMF)
#define BLEND_STOP_RSSI           15      //0:8, 1:10, 2:12, 3:14, 4:16, 5:18, 6:20, 7:22, 8:24, 9:26, 10:28, 11:30, 12:32, 13:34, 14:36, 15:38(unit:dbuVEMF)
#define BLEND_MOD                 0       //0: RSSI,    1: SNR
#define DBLND                     0       //0: blend enable,    1: blend disable
#define MONO                      0       //0: stereo,    1: force mono
#define BLEND_START_COMBO         2

#define DEPOP_TC                  3       //0:250ms,  1:500ms,    2:750ms,     3:1s
#define AUDV_DCLVL                2

#define FM_GAIN                   4       //0:0dB, 1:3.5dB, 2:6dB, 3:9.5dB, 4:-2.5dB, 5:-3.66dB, 6:-6dB, 7:-8.5dB

#define FM_AFCD                   0       //0:afc enable, 1:afc disable
#define FM_TH_AFC                 7       //0:5k, 1:15k, 2:25k, 3:35k, 4:50k, 5:100k, 6:150k, 7:200k

#define MW_AFCD                   0       //0:afc enable, 1:afc disable
#define MW_TH_AFC                 3 
#define FLT_SEL                   1       //0:1.2k, 1:2.4k, 2:3.6k, 3:4.8k, 4:6k

#define FM_DSMUTE                 0
#define FM_SMUTE_START_RSSI       5        //2     //yyq
#define FM_SMUTE_SLOPE_RSSI       3
#define FM_SMUTE_START_SNR        0x15
#define FM_SMUTE_SLOPE_SNR        4        //3  //yyq
#define FM_SMUTE_MIN_GAIN         3
#define TUNE_SMUTE_GAIN_FM        5

#define MW_DSMUTE                 0
#define MW_SMUTE_START_RSSI       0x17
#define MW_SMUTE_SLOPE_RSSI       4    
#define MW_SMUTE_START_SNR        0x30
#define MW_SMUTE_SLOPE_SNR        0        //2  //yyq
#define MW_SMUTE_MIN_GAIN         1    
#define TUNE_SMUTE_GAIN_AM        3

#define SW_EN                     1
#define SW_AFCD                   0        //0:afc enable, 1:afc disable
#define SW_TH_AFC                 3 

#define SW_DSMUTE                 0
#define SW_SMUTE_START_RSSI       0x17
#define SW_SMUTE_SLOPE_RSSI       4    
#define SW_SMUTE_START_SNR        0x30
#define SW_SMUTE_SLOPE_SNR        0        //2  //yyq
#define SW_SMUTE_MIN_GAIN         1    
#define TUNE_SMUTE_GAIN_SW        3

#define BAND_NUM                  17

enum Band_Mode  {
                    FM_MODE,    MW_MODE,    SW_MODE,    SW1_MODE,    SW2_MODE,
                    SW3_MODE,   SW4_MODE,   SW5_MODE,   SW6_MODE,    SW7_MODE,
                    SW8_MODE,   SW9_MODE,   SW10_MODE,  SW11_MODE,   SW12_MODE,
                    SW13_MODE,  SW14_MODE
                };
#define SW_STEP                AM_5KHz_STEP

#define SW_SEEK_UP_LIMIT      32000
#define SW_SEEK_DOWN_LIMIT    2000

#define SW_BAND_TOP           32000
#define SW_BAND_BOTTOM        2000

#define SW1_TOP_LIMIT         2495
#define SW1_BOTTOM_LIMIT      2300

#define SW2_TOP_LIMIT         3400
#define SW2_BOTTOM_LIMIT      3150

#define SW3_TOP_LIMIT         4000
#define SW3_BOTTOM_LIMIT      3850

#define SW4_TOP_LIMIT         5600
#define SW4_BOTTOM_LIMIT      4700

#define SW5_TOP_LIMIT         6200
#define SW5_BOTTOM_LIMIT      5700

#define SW6_TOP_LIMIT         7350
#define SW6_BOTTOM_LIMIT      7080

#define SW7_TOP_LIMIT         9900
#define SW7_BOTTOM_LIMIT      9200

#define SW8_TOP_LIMIT         12100
#define SW8_BOTTOM_LIMIT      11450

#define SW9_TOP_LIMIT         13870
#define SW9_BOTTOM_LIMIT      13500

#define SW10_TOP_LIMIT        15800
#define SW10_BOTTOM_LIMIT     15000

#define SW11_TOP_LIMIT        17900
#define SW11_BOTTOM_LIMIT     17450

#define SW12_TOP_LIMIT        19100
#define SW12_BOTTOM_LIMIT     18850

#define SW13_TOP_LIMIT        21850
#define SW13_BOTTOM_LIMIT     21430

#define SW14_TOP_LIMIT        26100
#define SW14_BOTTOM_LIMIT     24670

#define BandNumMax            16 //岨

UINT8 KT_AMFM_PreInit(void);
UINT8 KT_AMFM_Init(void);
UINT8 KT_AMFM_VolumeSet(UINT8 cVol);
UINT8 KT_FM_ReadRSSI(void);
UINT8 KT_AM_ReadRSSI(void);
UINT16 KT_FM_GetFreq(void);
UINT16 KT_AM_GetFreq(void);
UINT8 KT_FM_GetSNR(void);
UINT8 KT_AM_GetSNR(void);
BOOL KT_AMFM_GetST(void);
void KT_AMFM_SetMode(void);
static void KT093x_STEP_Config(enum Band_Mode spanMode);
static void KT_Byte_Write(UINT8 Register_Address, UINT8 Byte_Data);
static UINT8 KT_Byte_Read(UINT8 Register_Address);
static void KT093x_bandChan_Config(void);
static void KT093x_ADC_Config(BOOL adcSwitch);

struct Str_Band
{
    enum Band_Mode    Band;                       // Ƶ
    UINT16            BandLowChan;                // ε
    UINT8             BandSpace;                  // chan
    UINT16            BandChanNum;                // chan
    UINT8             BandGuard;                  // guard
    UINT16            BandChanWin;                // adcڴС
};
extern struct Str_Band     *pBand;

extern UINT16 freqCurrnet;
extern UINT16 freqMin;
extern UINT16 freqMax;
extern UINT8  freqStep;
extern struct Str_Band code KT093xBand[16];